import os

from django.conf import settings
from packaging import version as _ver
from uuid import uuid4

from django.contrib.auth import get_user_model
from django.contrib.postgres.fields import JSONField
from django.core.exceptions import ValidationError, ObjectDoesNotExist
from django.db import models
from django.db.models import Q
from django.utils import timezone
from django.utils.translation import gettext_lazy as _
from rolepermissions.checkers import has_role
from accounts.models import ELGUser
from utils.sorting_utils import sort_list_of_tuples
from email_notifications.tasks import curator_content_manager_notifications, version_inactive_notification
from management import ELG_STORAGE

from management.utils.publication_field_generation import AutomaticPublicationFieldGeneration

# Publication status constants and choice:
DRAFT = 'd'
INTERNAL = 'i'
INGESTED = 'g'
PUBLISHED = 'p'
UNPUBLISHED = 'u'
STATUS_CHOICES = (
    (DRAFT, 'draft'),
    (INTERNAL, 'internal'),
    (INGESTED, 'ingested'),
    (PUBLISHED, 'published'),
    (UNPUBLISHED, 'unpublished'),
)


def _create_uuid():
    """
    Creates a unique id from a UUID-4, checks for collisions.
    """
    # Create new identifier based on a UUID-1 and a UUID-4.
    new_id = uuid4().hex

    # Check for collisions; in case of a collision, create new identifier.
    while Manager.objects.filter(identifier=new_id).exists():
        new_id = uuid4().hex
    return new_id


def get_assignee(available_validators):
    """
    Get available validator with the lowest workload
    """
    assignee = (0, 0)
    for validator in available_validators:
        assignee_tuple = (validator.user.id, len(validator.assigned_to.all()))
        assignee = assignee_tuple if assignee_tuple[1] < assignee[1] else assignee
        if assignee == (0, 0):
            assignee = assignee_tuple
    return assignee


class ContentFile(models.Model):
    """
    Information of the stored dataset. The dataset
    is either uploaded, or generated by the processing
    infrastructure
    """
    file = models.FileField(
        storage=ELG_STORAGE,
        max_length=2048,
        unique=True,
    )
    date_stored = models.DateTimeField(auto_now_add=True)
    record_manager = models.ForeignKey(
        'management.Manager',
        related_name='content_files',
        null=True,
        on_delete=models.CASCADE
    )

    @property
    def filename(self):
        return os.path.basename(self.file.name)

    def get_file_type(self):
        _, file_type = os.path.splitext(self.file.name)
        return file_type


class Manager(models.Model):
    """
    Class that manages the registry app metadata records.
    """

    identifier = models.CharField(
        max_length=64,
        default=_create_uuid,
        editable=False,
        unique=True,
        help_text="(Read-only) unique identifier for this management object instance."
    )

    status = models.CharField(
        default=INTERNAL,
        max_length=1,
        choices=STATUS_CHOICES,
        help_text=''
    )

    creation_date = models.DateField(
        blank=True, null=True,
        auto_now_add=True
    )

    date_last_modified = models.DateTimeField(
        blank=True, null=True,
        auto_now=True
    )

    ingestion_date = models.DateTimeField(null=True)

    legal_validation_date = models.DateTimeField(null=True)

    metadata_validation_date = models.DateTimeField(null=True)

    technical_validation_date = models.DateTimeField(null=True)

    approval_date = models.DateTimeField(null=True)

    publication_date = models.DateTimeField(null=True)

    unpublication_date = models.DateTimeField(null=True)

    deleted = models.BooleanField(default=False)

    under_construction = models.BooleanField(default=False)

    for_information_only = models.BooleanField(default=False)

    from_ele = models.BooleanField(default=False)

    functional_service = models.BooleanField(default=False)

    service_compliant_dataset = models.BooleanField(default=False)

    claimed = models.CharField(
        max_length=150,
        blank=True,
        null=True
    )

    unpublication_requested = models.BooleanField(default=False)

    curator = models.ForeignKey(
        ELGUser,
        null=True,
        on_delete=models.SET_NULL,
        related_name='record_managers_of_curator',
        verbose_name=_('Curator')
    )

    legal_validator = models.ForeignKey(
        ELGUser,
        null=True,
        on_delete=models.SET_NULL,
        related_name='record_managers_of_legal_validator',
        verbose_name=_('Legal validator')
    )

    metadata_validator = models.ForeignKey(
        ELGUser,
        null=True,
        on_delete=models.SET_NULL,
        related_name='record_managers_of_metadata_validator',
        verbose_name=_('Metadata validator')
    )

    technical_validator = models.ForeignKey(
        ELGUser,
        null=True,
        on_delete=models.SET_NULL,
        related_name='record_managers_of_technical_validator',
        verbose_name=_('Technical validator')
    )

    legally_valid = models.BooleanField(null=True)

    metadata_valid = models.BooleanField(null=True)

    technically_valid = models.BooleanField(null=True)

    slack_channel = models.URLField(blank=True, null=True)
    jira_ticket = models.URLField(blank=True, null=True)

    validator_notes = models.CharField(max_length=2000,
                                       blank=True,
                                       null=True,
                                       help_text='Internal notes (visible only to other validators)')
    review_comments = models.CharField(max_length=2000,
                                       blank=True,
                                       null=True,
                                       help_text='Please state the reasons for rejecting this record '
                                                 '(to be sent out to the curator)')

    landing_page_display = JSONField(blank=True, null=True)
    uncensored_landing_page_display = JSONField(blank=True, null=True)
    json_ld = JSONField(blank=True, null=True)

    is_latest_version = models.BooleanField(default=False)
    is_active_version = models.BooleanField(default=False)
    proxied = models.BooleanField(null=True)
    inactive_status = models.CharField(
        null=True,
        max_length=16,
        choices=[
            ('CONTACT PROVIDER', 'Contact Provider'),
            ('DOWNLOADABLE', 'Downloadable'),
        ],
        help_text='Status of inactive service'
    )

    versioned_record_managers = models.ManyToManyField(
        'self',
        symmetrical=True,
        blank=True,
        help_text=_("Identifies the different versions of the record's management object"
                    " When a new version is released, the versioned record managers "
                    "are cross-linked.")
    )

    class Meta:
        ordering = ('-pk',)

    def __str__(self):
        return f'Manager of {self.metadata_record_of_manager.__str__()}'

    @property
    def has_content_file(self):
        return self.content_files.exists()

    @property
    def is_claimable(self):
        if self.curator and not self.curator.username == settings.SYSTEM_USER:
            return False
        else:
            if self.metadata_record_of_manager.described_entity.entity_type == 'LanguageResource' \
                    and getattr(self.metadata_record_of_manager.described_entity, 'lr_subclass', None) \
                    and not getattr(self.metadata_record_of_manager.described_entity.lr_subclass,
                                    'ld_subclass', None) == 'http://w3id.org/meta-share/meta-share/model' \
                    and getattr(self.metadata_record_of_manager.described_entity.lr_subclass, 'unspecified_part', None):
                return False
            else:
                if self.status == PUBLISHED \
                        and not self.claimed:
                    return True
                return False

    def assign_validators(self, vld_type):
        if vld_type == 'legal_validator':
            available_validators = Validator.objects.filter(assigned_for='Legal')
        elif vld_type == 'metadata_validator':
            available_validators = Validator.objects.filter(assigned_for='Metadata')
        elif vld_type == 'technical_validator' and not self.has_content_file:
            available_validators = Validator.objects.filter(assigned_for='Technical')
        else:
            available_validators = Validator.objects.none()
        if available_validators.count() != 0:
            assignee_id = get_assignee(available_validators)[0]
            setattr(self, vld_type, get_user_model().objects.get(id=assignee_id))
            if self.has_content_file and vld_type == 'metadata_validator' and not self.under_construction:
                setattr(self, 'technical_validator', get_user_model().objects.get(id=assignee_id))
            assignee_validator = available_validators.get(user__id=assignee_id)
            assignee_validator.assigned_to.add(self.id)
            assignee_validator.save()

    def generate_landing_page_display(self):
        apf = AutomaticPublicationFieldGeneration(self.metadata_record_of_manager)
        apf.generate_landing_page(save_manager=True)

    def update_landing_pages_of_related_records(self, request_user=None):
        from registry.serializers import MetadataRecordSerializer
        MetadataRecordSerializer(self.metadata_record_of_manager).update_related_landing_pages(
            request_user=request_user)

    def ingest(self):
        """
        Ingest instance. This method is called automatically
        when on edit form the user pushes the final save button.
        """
        if self.status == INTERNAL and not self.deleted:
            self.status = INGESTED
            self.ingestion_date = timezone.now()
            if self.under_construction \
                    or not (self.functional_service or self.has_content_file):
                self.legally_valid = True
                self.technically_valid = True

            if self.versioned_record_managers.exists() \
                    and any([self.legal_validator is None,
                             self.metadata_validator is None,
                             self.technical_validator is None]):
                self.handle_version_validators()

            if not self.legal_validator and self.legally_valid is None and not self.functional_service:
                self.assign_validators('legal_validator')

            if not self.technical_validator and self.technically_valid is None and not self.functional_service:
                self.assign_validators('technical_validator')

            if not self.metadata_validator and self.metadata_valid is None \
                    and not (self.functional_service and not self.under_construction):
                self.assign_validators('metadata_validator')

            if any([self.legally_valid is False, self.metadata_valid is False, self.technically_valid is False]):
                if self.under_construction \
                        or not (self.functional_service or self.has_content_file):
                    self.legally_valid = True
                    self.legal_validator = None
                    self.metadata_valid = None
                    if not self.metadata_validator \
                            or (self.metadata_validator
                                and not has_role(self.metadata_validator, 'metadata_validator')):
                        self.assign_validators('metadata_validator')
                    self.technically_valid = True
                    self.technical_validator = None
                else:
                    self.legally_valid = None
                    if (not self.legal_validator
                        or (self.legal_validator
                            and not has_role(self.legal_validator, 'legal_validator'))) \
                            and not self.functional_service:
                        self.assign_validators('legal_validator')
                    if self.legal_validator \
                            and not has_role(self.legal_validator, 'legal_validator') \
                            and self.functional_service:
                        self.legal_validator = None
                    self.metadata_valid = None
                    if (not self.metadata_validator
                        or (self.metadata_validator
                            and not has_role(self.metadata_validator, 'metadata_validator'))) \
                            and not (self.functional_service and not self.under_construction):
                        self.assign_validators('metadata_validator')
                    if self.metadata_validator \
                            and not has_role(self.metadata_validator, 'technical_validator') \
                            and self.functional_service:
                        self.metadata_validator = None
                    self.technically_valid = None
                    if not self.technical_validator and not self.functional_service:
                        self.assign_validators('technical_validator')
                        # handling the issue of adding data to a resource after a negative validation review
                        if self.has_content_file:
                            self.technical_validator = self.metadata_validator
                    if self.technical_validator \
                            and not has_role(self.technical_validator, 'technical_validator') \
                            and self.functional_service:
                        self.technical_validator = None
                    if self.technical_validator \
                            and has_role(self.technical_validator, 'technical_validator') \
                            and (not self.metadata_validator or (self.metadata_validator != self.technical_validator)) \
                            and self.functional_service:
                        self.metadata_validator = self.technical_validator
                    if self.technical_validator \
                            and not has_role(self.technical_validator, 'metadata_validator') \
                            and self.has_content_file:
                        self.technical_validator = self.metadata_validator
            self.save()
            return True
        return False

    def approve(self, updated_fields=tuple(), legal_approval=None, metadata_approval=None, technical_approval=None):
        if self.status == INGESTED and not self.deleted:
            if 'legally_valid' in updated_fields and legal_approval is not None:
                self.legally_valid = legal_approval
                self.legal_validation_date = timezone.now()
                self.save()
            if 'metadata_valid' in updated_fields and metadata_approval is not None:
                self.metadata_valid = metadata_approval
                self.metadata_validation_date = timezone.now()
                self.save()
            if 'technically_valid' in updated_fields and technical_approval is not None:
                self.technically_valid = technical_approval
                self.technical_validation_date = timezone.now()
                self.save()
            validation_status = ''
            if self.legally_valid and self.metadata_valid and self.technically_valid:
                self.status = PUBLISHED
                self.approval_date = timezone.now()
                self.publication_date = timezone.now()
                self.save()
                apf = AutomaticPublicationFieldGeneration(self.metadata_record_of_manager)
                apf.generate_json_ld()
                apf.generate_landing_page(save_manager=True)
                self.update_landing_pages_of_related_records()
                if not self.functional_service \
                        and getattr(self.metadata_record_of_manager, 'lt_service', False):
                    self.metadata_record_of_manager.lt_service.status = 'DELETED'
                    self.metadata_record_of_manager.lt_service.save()
                validation_status = 'approval'
                if self.legal_validator:
                    try:
                        legal_val = Validator.objects.get(user=self.legal_validator, assigned_for='Legal')
                        legal_val.assigned_to.remove(self.id)
                        legal_val.save()
                    except ObjectDoesNotExist:
                        pass
                if self.metadata_validator:
                    try:
                        meta_val = Validator.objects.get(user=self.metadata_validator, assigned_for='Metadata')
                        meta_val.assigned_to.remove(self.id)
                        meta_val.save()
                    except ObjectDoesNotExist:
                        pass
                if self.technical_validator:
                    try:
                        tech_val = Validator.objects.get(user=self.technical_validator, assigned_for='Technical')
                        tech_val.assigned_to.remove(self.id)
                        tech_val.save()
                    except ObjectDoesNotExist:
                        pass

            elif any([self.legally_valid is False, self.metadata_valid is False, self.technically_valid is False]):
                self.status = INTERNAL
                self.save()
                validation_status = 'rejection'

            if validation_status:
                validation_review = self.review_comments.split(' | ')[0] \
                    if validation_status == 'rejection' else self.review_comments
                curator_content_manager_notifications.apply_async(args=[[self.metadata_record_of_manager.id],
                                                                        validation_status,
                                                                        validation_review])

    def publish(self, force=False):
        if self.status is not PUBLISHED and (
                self.status in [INGESTED, UNPUBLISHED] or force is True) and not self.deleted:
            self.status = PUBLISHED
            self.publication_date = timezone.now()
            self.save()
            apf = AutomaticPublicationFieldGeneration(self.metadata_record_of_manager)
            apf.generate_json_ld()
            apf.generate_landing_page(save_manager=True)
            self.update_landing_pages_of_related_records()
            if not self.functional_service \
                    and getattr(self.metadata_record_of_manager, 'lt_service', False):
                self.metadata_record_of_manager.lt_service.status = 'DELETED'
                self.metadata_record_of_manager.lt_service.save()
            if not force:
                if self.legal_validator:
                    try:
                        legal_val = Validator.objects.get(user=self.legal_validator, assigned_for='Legal')
                        legal_val.assigned_to.remove(self.id)
                        legal_val.save()
                    except ObjectDoesNotExist:
                        pass
                if self.metadata_validator:
                    try:
                        meta_val = Validator.objects.get(user=self.metadata_validator, assigned_for='Metadata')
                        meta_val.assigned_to.remove(self.id)
                        meta_val.save()
                    except ObjectDoesNotExist:
                        pass
                if self.technical_validator:
                    try:
                        tech_val = Validator.objects.get(user=self.technical_validator, assigned_for='Technical')
                        tech_val.assigned_to.remove(self.id)
                        tech_val.save()
                    except ObjectDoesNotExist:
                        pass
                curator_content_manager_notifications.apply_async(args=[[self.metadata_record_of_manager.id],
                                                                        'publication'])
                # if publish is forced, approve all validations
            else:
                self.legally_valid = True
                self.metadata_valid = True
                self.technically_valid = True
                self.save()
            return True
        return False

    def unpublish(self, notify=True, unpublication_reason=None):
        if self.status is PUBLISHED and not self.deleted:
            if not self.under_construction:
                self.status = UNPUBLISHED
                self.unpublication_date = timezone.now()
            else:
                self.status = INTERNAL
                self.under_construction = False
                self.legally_valid = None
                self.metadata_valid = None
                self.technically_valid = None
            if self.unpublication_requested:
                self.unpublication_requested = False
            self.save()
            # update published relations of record
            self.update_landing_pages_of_related_records(
                request_user=self.curator)
            if notify:
                curator_content_manager_notifications.apply_async(args=[[self.metadata_record_of_manager.id],
                                                                        'unpublication',
                                                                        unpublication_reason])
            return True
        return False

    def mark_as_deleted(self):
        if self.deleted or self.status == 'p':
            return False
        self.deleted = True
        self.save()
        # Handle versioning
        self.handle_version_deletion()
        if getattr(self.metadata_record_of_manager, 'lt_service', None):
            self.metadata_record_of_manager.lt_service.status = 'DELETED'
            self.metadata_record_of_manager.lt_service.save()
        return True

    def undo_mark_deleted(self):
        if self.deleted:
            self.deleted = False
            self.save()
            if getattr(self.metadata_record_of_manager, 'lt_service', None):
                self.metadata_record_of_manager.lt_service.status = 'PENDING'
                self.metadata_record_of_manager.lt_service.save()
            return True
        return False

    def claim(self, claimed_by):
        if self.is_claimable:
            self.claimed = claimed_by
            self.save()
            # update published relations of record
            self.update_landing_pages_of_related_records(
                request_user=self.curator)
            return True
        return False

    def request_unpublication(self):
        if self.status == PUBLISHED and not self.unpublication_requested:
            self.unpublication_requested = True
            self.save()
            return True
        return False

    def internalize(self):
        if self.status in [INGESTED, UNPUBLISHED]:
            self.status = INTERNAL
            self.legally_valid = None
            self.metadata_valid = None
            self.technically_valid = None
            self.save()
            return True
        return False

    def deactivate_older_version(self):
        if self.status == PUBLISHED \
                and self.is_active_version \
                and not self.is_latest_version \
                and getattr(self.metadata_record_of_manager, 'lt_service', None):
            self.is_active_version = False
            self.metadata_record_of_manager.lt_service.status = 'DEPRECATED'
            self.metadata_record_of_manager.lt_service.save()
            for software_distribution in self.metadata_record_of_manager.described_entity.lr_subclass.software_distribution.all():
                if software_distribution.software_distribution_form == 'http://w3id.org/meta-share/meta-share/dockerImage':
                    if software_distribution.private_resource:
                        self.inactive_status = 'CONTACT PROVIDER'
                    else:
                        self.inactive_status = 'DOWNLOADABLE'
                    break
            self.save()
            self.generate_landing_page_display()
            return True
        return False

    def create_resource_version(self, version, version_date, resource_name, functional=False):
        if self.status == PUBLISHED:
            from registry.serializers import (
                MetadataRecordSerializer,
                GenericProjectSerializer,
                GenericOrganizationSerializer
            )
            from nested_lookup import nested_delete
            keep_validators = True
            initial_serializer = MetadataRecordSerializer(instance=self.metadata_record_of_manager)
            clean_data = nested_delete(initial_serializer.data, 'pk')
            new_version_serializer = MetadataRecordSerializer(data=clean_data, context={'draft': True})
            version_data = new_version_serializer.initial_data
            entity_type = self.metadata_record_of_manager.described_entity.entity_type
            if entity_type == 'LanguageResource':
                lr_type = self.metadata_record_of_manager.described_entity.lr_subclass.lr_type
                version_data['described_entity']['lr_identifier'] = []
                version_data['described_entity']['version'] = version
                version_data['described_entity']['replaces'] = []
                if version_date:
                    version_data['described_entity']['version_date'] = version_date
                if lr_type == 'ToolService':
                    distribution = version_data['described_entity']['lr_subclass']['software_distribution']
                    for dist in distribution:
                        dist['package'] = None
                else:
                    distribution = version_data['described_entity']['lr_subclass']['dataset_distribution']
                    for dist in distribution:
                        dist['dataset'] = None
                if functional or self.has_content_file:
                    keep_validators = False
            if entity_type == 'Project':
                version_data['described_entity']['project_identifier'] = []
                version_data['described_entity']['project_short_name'] = None
                version_data['described_entity']['project_name'] = {
                    'en': resource_name
                }
                version_data['described_entity']['replaces_project'] = \
                    clean_data['described_entity']['replaces_project'] + [
                        GenericProjectSerializer(instance=self.metadata_record_of_manager.described_entity).data]
            if entity_type == 'Organization':
                version_data['described_entity']['organization_identifier'] = []
                version_data['described_entity']['organization_short_name'] = None
                version_data['described_entity']['organization_name'] = {
                    'en': resource_name
                }
                version_data['described_entity']['replaces_organization'] = \
                    clean_data['described_entity']['replaces_organization'] + [
                        GenericOrganizationSerializer(instance=self.metadata_record_of_manager.described_entity).data]
            version_data['management_object'] = {
                'status': DRAFT,
                'curator': self.curator.pk,
                'legal_validator': self.legal_validator.pk if (self.legal_validator and keep_validators) else None,
                'metadata_validator': self.metadata_validator.pk if (
                        self.metadata_validator and keep_validators) else None,
                'technical_validator': self.technical_validator.pk if (
                        self.technical_validator and keep_validators) else None,
                'functional_service': functional
            }
            new_version_serializer.is_valid(raise_exception=True)
            new_version_record = new_version_serializer.save()

            if entity_type == 'LanguageResource':
                # Cross link the record managers of the same version
                new_version_record.management_object.versioned_record_managers.add(
                    self, *self.versioned_record_managers.all()
                )
                new_version_record.management_object.save()
                # Handle replaces
                external_replaced_lrs = self.metadata_record_of_manager.described_entity.replaces.filter(
                    metadata_record_of_described_entity__isnull=True
                )
                if external_replaced_lrs.exists():
                    new_version_record.described_entity.replaces.add(*external_replaced_lrs)

                # Add earlier versions
                earlier_versioned_record_managers = new_version_record.management_object.versioned_record_managers.filter(
                    status=PUBLISHED,
                    deleted=False
                )
                earlier_version_ids = []
                for version_record in earlier_versioned_record_managers:
                    if _ver.parse(version) > _ver.parse(
                            version_record.metadata_record_of_manager.described_entity.version):
                        earlier_version_ids.append(version_record.id)
                if _ver.parse(version) > _ver.parse(self.metadata_record_of_manager.described_entity.version):
                    earlier_version_ids.append(self.pk)
                earlier_versioned_records = new_version_record.management_object.versioned_record_managers.filter(
                    pk__in=earlier_version_ids,
                    deleted=False
                )
                if earlier_versioned_records.exists():
                    new_version_record.described_entity.replaces.add(
                        *earlier_versioned_records.order_by(
                            '-metadata_record_of_manager__described_entity__languageresource__version'
                        ).values_list(
                            'metadata_record_of_manager__described_entity__languageresource', flat=True
                        )
                    )
                new_version_record.save()

            if keep_validators:
                if self.legal_validator:
                    legal_val = Validator.objects.get(user=self.legal_validator, assigned_for='Legal')
                    legal_val.assigned_to.add(new_version_record.management_object.id)
                    legal_val.save()
                if self.metadata_validator:
                    meta_val = Validator.objects.get(user=self.metadata_validator, assigned_for='Metadata')
                    meta_val.assigned_to.add(new_version_record.management_object.id)
                    meta_val.save()
                if self.technical_validator:
                    tech_val = Validator.objects.get(user=self.technical_validator, assigned_for='Technical')
                    tech_val.assigned_to.add(new_version_record.management_object.id)
                    tech_val.save()

            # update published relations of record
            new_version_record.management_object.update_landing_pages_of_related_records(
                request_user=self.curator)

            return new_version_record
        return None

    def handle_version_publication(self, catalogue_records):
        """
        Handle versioning when a new version gets published
        1. If no other published versions:
            - Set the latest version flag to the new published version
            - Add the new one to the catalogue
        2. If other published version
            2.a if version < other published versions:
                - Add this record to the replaces metadata of the > versioned records
            2.b If version > other published versions:
                - Check if replaces of this record needs to be updated and update with
                < published versions
            2.c If the new one is the latest version:
                - Set the latest version flag to the new published version
                - Add the new one to the catalogue
                - Remove from indexer the previous
        :param catalogue_records: the record managers
        that are going to be viewed in the catalogue
        """
        if self.metadata_record_of_manager.described_entity.entity_type != 'LanguageResource':
            return None

        from registry.models import MetadataRecord
        from registry.search_indexes.documents import MetadataDocument

        # first published version of the record
        if not self.versioned_record_managers.filter(status=PUBLISHED).exists():
            self.is_latest_version = True
            self.is_active_version = True
            catalogue_records.append(self.metadata_record_of_manager)
        # Update the concept record to resolve to the most recent version
        else:
            record_version = self.metadata_record_of_manager.described_entity.version
            # Handle replaces for earlier versions
            earlier_versioned_record_managers = self.versioned_record_managers.filter(
                status=PUBLISHED,
                deleted=False
            )
            earlier_version_ids = []
            for version_record in earlier_versioned_record_managers:
                if _ver.parse(record_version) > _ver.parse(
                        version_record.metadata_record_of_manager.described_entity.version):
                    earlier_version_ids.append(version_record.id)
            minor_versioned_lrs = self.versioned_record_managers.filter(
                pk__in=earlier_version_ids
            ).values_list('metadata_record_of_manager__described_entity__languageresource', flat=True)
            missing_minor_versioned_lrs = self.metadata_record_of_manager.described_entity.replaces.exclude(
                pk__in=minor_versioned_lrs
            )
            if missing_minor_versioned_lrs.exists():
                self.metadata_record_of_manager.described_entity.replaces.add(
                    *missing_minor_versioned_lrs.order_by('-version')
                )

            # Handle replaces for greater versions
            greater_versioned_record_managers = self.versioned_record_managers.filter(
                status=PUBLISHED,
                deleted=False
            )
            greater_version_ids = []
            for version_record in greater_versioned_record_managers:
                if _ver.parse(record_version) < _ver.parse(
                        version_record.metadata_record_of_manager.described_entity.version):
                    greater_version_ids.append(version_record.id)
            greater_versioned_records = MetadataRecord.objects.filter(
                management_object__pk__in=greater_version_ids).exclude(
                described_entity__languageresource__replaces=self.metadata_record_of_manager.described_entity.languageresource
            )
            if greater_versioned_records.exists():
                # Update the indexer of the latest version
                latest_versioned_record = greater_versioned_records.get(management_object__is_latest_version=True)
                for greater_r in greater_versioned_records:
                    greater_r.described_entity.replaces.add(
                        self.metadata_record_of_manager.described_entity.languageresource
                    )
                    apf = AutomaticPublicationFieldGeneration(greater_r)
                    apf.generate_json_ld()
                    apf.generate_landing_page(save_manager=True)
                MetadataDocument().catalogue_update(latest_versioned_record, action='index')
            if not greater_versioned_records.exists():
                # The new published version is the latest
                # update the latest version
                self.is_latest_version = True
                self.is_active_version = True
                catalogue_records.append(self.metadata_record_of_manager)
                if self.versioned_record_managers.filter(is_latest_version=True).exists():
                    # Update former latest versions
                    former_latest_versioned_record_managers = self.versioned_record_managers.filter(
                        is_latest_version=True)
                    former_latest_pks = list(former_latest_versioned_record_managers.all().values_list('pk', flat=True))
                    former_latest_versioned_records = MetadataRecord.objects.filter(
                        management_object__in=former_latest_pks
                    )
                    former_latest_versioned_record_managers.update(is_latest_version=False)
                    # Remove them from the indexer
                    for record in former_latest_versioned_records:
                        apf = AutomaticPublicationFieldGeneration(record)
                        apf.generate_json_ld()
                        apf.generate_landing_page(save_manager=True)
                    MetadataDocument().catalogue_update(former_latest_versioned_records, action='delete')

            # handle active versions
            all_published_versions = list(self.versioned_record_managers.filter(status=PUBLISHED))
            all_published_versions.append(self)
            initial_version_list = [
                (i, _ver.parse(i.metadata_record_of_manager.described_entity.version)) for i in all_published_versions
            ]
            sorted_version_list = sort_list_of_tuples(initial_version_list)
            for version, _v in sorted_version_list:
                management_tag_changed = False
                lt_tag_changed = False
                if (version, _v) in sorted_version_list[0:3] and not version.is_active_version:
                    version.is_active_version = True
                    management_tag_changed = True
                elif (version, _v) in sorted_version_list[3:] \
                        and version.is_active_version:
                    version.is_active_version = False
                    if getattr(version.metadata_record_of_manager, 'lt_service', None) \
                            and version.metadata_record_of_manager.lt_service.status != 'DEPRECATED':
                        version.metadata_record_of_manager.lt_service.status = 'DEPRECATED'
                        lt_tag_changed = True
                    for software_distribution in self.metadata_record_of_manager.described_entity.lr_subclass.software_distribution.all():
                        if software_distribution.software_distribution_form == 'http://w3id.org/meta-share/meta-share/dockerImage':
                            if software_distribution.private_resource:
                                self.inactive_status = 'CONTACT PROVIDER'
                            else:
                                self.inactive_status = 'DOWNLOADABLE'
                            break
                    management_tag_changed = True
                    version_inactive_notification.apply_async(args=[self.metadata_record_of_manager.pk,
                                                                    version.metadata_record_of_manager.pk])
                if management_tag_changed:
                    version.save()
                if lt_tag_changed:
                    version.metadata_record_of_manager.lt_service.save()

    def handle_version_unpublication(self):
        """
        Handle versioning when a published records gets unpublished
        1. Unset latest version to False
        2. If other published records exists:
            - Find the latest
            - Set the latest version flag to the new
            - Add to the indexer the newest latest version
        """
        if self.metadata_record_of_manager.described_entity.entity_type != 'LanguageResource':
            return None

        from registry.models import MetadataRecord
        from registry.search_indexes.documents import MetadataDocument

        if self.is_latest_version:
            self.is_latest_version = False
            self.save()

            # Set the latest version to the previous one if exists
            if self.versioned_record_managers.filter(status=PUBLISHED, deleted=False).exists():
                latest_versioned_manager = self.versioned_record_managers.filter(
                    status=PUBLISHED,
                    deleted=False
                ).latest('metadata_record_of_manager__described_entity__languageresource__version')
                latest_versioned_manager.is_latest_version = True
                latest_versioned_manager.is_active_version = True
                latest_versioned_manager.save()
                # Update catalogue indexer
                MetadataDocument().catalogue_update(latest_versioned_manager.metadata_record_of_manager, action='index')

    def handle_version_deletion(self):
        """
        Handle versioning when the record gets deleted.
        - Remove from the greater versioned record the replaces metadata
        that refer to this record's lr
        """
        if self.metadata_record_of_manager.described_entity.entity_type != 'LanguageResource':
            return None

        from registry.models import MetadataRecord

        records_version = self.metadata_record_of_manager.described_entity.version

        greater_versioned_record_managers = self.versioned_record_managers.filter(
            deleted=False
        )
        greater_version_ids = []
        for version_record in greater_versioned_record_managers:
            if _ver.parse(records_version) < _ver.parse(
                    version_record.metadata_record_of_manager.described_entity.version):
                greater_version_ids.append(version_record.id)

        greater_versioned_records = MetadataRecord.objects.filter(
            management_object__pk__in=greater_version_ids,
            described_entity__languageresource__replaces=self.metadata_record_of_manager.described_entity.languageresource
        )
        for greater_r in greater_versioned_records:
            greater_r.described_entity.replaces.remove(
                self.metadata_record_of_manager.described_entity.languageresource
            )

        for published_version_manager in self.versioned_record_managers.filter(status=PUBLISHED, deleted=False):
            published_version_manager.generate_landing_page_display()

    def handle_version_validators(self):
        if self.functional_service:
            functional_versions = self.versioned_record_managers.filter(functional_service=True).order_by(
                '-metadata_record_of_manager__described_entity__languageresource__version'
            )
            if functional_versions.exists():
                last_version = functional_versions.first()
                self.legal_validator = last_version.legal_validator
                self.metadata_validator = last_version.technical_validator
                self.technical_validator = last_version.technical_validator

        elif self.has_content_file:
            has_data_versions = self.versioned_record_managers.filter(content_files__isnull=False).order_by(
                '-metadata_record_of_manager__described_entity__languageresource__version'
            )
            if has_data_versions.exists():
                has_data_version = has_data_versions.first()
                self.legal_validator = has_data_version.legal_validator
                self.metadata_validator = has_data_version.metadata_validator
                self.technical_validator = has_data_version.metadata_validator
            else:
                for version in self.versioned_record_managers.all().order_by(
                        '-metadata_record_of_manager__described_entity__languageresource__version'):
                    if has_role(version.metadata_validator, 'metadata_validator'):
                        self.metadata_validator = version.metadata_validator
                        self.technical_validator = version.metadata_validator
                    break
        else:
            for version in self.versioned_record_managers.all().order_by(
                    '-metadata_record_of_manager__described_entity__languageresource__version'):
                if has_role(version.metadata_validator, 'metadata_validator'):
                    self.metadata_validator = version.metadata_validator
                break

    def handle_version_editing(self, validated_version):
        """
        1. If was > and now < than other published versions:
            - Remove from replaces the > published versions
        2. If was < and now > than other published versions:
            - Add to replaces the other published versions
        """
        if self.metadata_record_of_manager.described_entity.entity_type != 'LanguageResource':
            return None

        from registry.models import MetadataRecord
        # Remove from replaces the lrs that are no longer greater than the current version
        greater_versioned_records = self.metadata_record_of_manager.described_entity.replaces.all()
        greater_version_ids = []
        for version_record in greater_versioned_records:
            if _ver.parse(validated_version) < _ver.parse(
                    version_record.version):
                greater_version_ids.append(version_record.id)
        false_replaced_lrs = self.metadata_record_of_manager.described_entity.replaces.filter(
            pk__in=greater_version_ids
        )
        if false_replaced_lrs.exists():
            self.metadata_record_of_manager.described_entity.replaces.remove(*false_replaced_lrs)

        # Add to replaces the lrs that have minor version than the validated one
        # Handle replaces for earlier versions
        earlier_versioned_record_managers = self.versioned_record_managers.filter(
            status=PUBLISHED,
            deleted=False
        )
        earlier_version_ids = []
        for version_record in earlier_versioned_record_managers:
            if _ver.parse(validated_version) > _ver.parse(
                    version_record.metadata_record_of_manager.described_entity.version):
                earlier_version_ids.append(version_record.id)
        minor_versioned_lrs = self.versioned_record_managers.filter(
            pk__in=earlier_version_ids).values_list(
            'metadata_record_of_manager__described_entity__languageresource', flat=True)
        missing_minor_versioned_lrs = self.metadata_record_of_manager.described_entity.replaces.exclude(
            pk__in=minor_versioned_lrs
        )
        if missing_minor_versioned_lrs.exists():
            self.metadata_record_of_manager.described_entity.replaces.add(
                *missing_minor_versioned_lrs.order_by('-version')
            )

    def handle_replaces_editing(self, validated_replaces, request_user):
        """
        Handle versioning when user adds replaces relation.
        - Cross link the versions
        - Add concept pid to the version if does not exist
        - Add to replaces the earlier versions too
        """
        if self.metadata_record_of_manager.described_entity.entity_type != 'LanguageResource':
            return None

        record_version = self.metadata_record_of_manager.described_entity.version
        for lr in validated_replaces:
            try:
                replaced_m = lr.metadata_record_of_described_entity.management_object
            except AttributeError:
                continue
            else:
                # Cross link the record managers of the same version
                self.versioned_record_managers.clear()
                self.versioned_record_managers.add(
                    replaced_m, *replaced_m.versioned_record_managers.all()
                )
                # Handle replaces to other versions too
                earlier_versioned_record_managers = self.versioned_record_managers.filter(
                    (Q(status=PUBLISHED) | (Q(curator=request_user) &
                                            ~Q(status=DRAFT))),
                    Q(deleted=False)
                )
                earlier_version_ids = []
                for version_record in earlier_versioned_record_managers:
                    if _ver.parse(record_version) > _ver.parse(
                            version_record.metadata_record_of_manager.described_entity.version):
                        earlier_version_ids.append(version_record.id)
                earlier_versioned_records = replaced_m.versioned_record_managers.filter(
                    pk__in=earlier_version_ids).order_by(
                    '-metadata_record_of_manager__described_entity__languageresource__version'
                )
                if earlier_versioned_records.exists():
                    self.metadata_record_of_manager.described_entity.replaces.add(
                        *earlier_versioned_records.values_list(
                            'metadata_record_of_manager__described_entity__languageresource', flat=True
                        )
                    )

                external_replaced_lrs = replaced_m.metadata_record_of_manager.described_entity.replaces.filter(
                    metadata_record_of_described_entity__isnull=True
                )

                if external_replaced_lrs.exists():
                    self.metadata_record_of_manager.described_entity.replaces.add(*external_replaced_lrs)

    def copy_resource(self, resource_name, version, given_name, functional=False):
        from registry.serializers import MetadataRecordSerializer
        from nested_lookup import nested_delete
        from registry.models_identifier_mapping import sender_mapping_relation
        if self.status not in [DRAFT]:
            keep_validators = True
            resource_name_mapping = {
                'LanguageResource': 'resource_name',
                'Project': 'project_name',
                'Organization': 'organization_name',
                'Group': 'organization_name',
                'Person': 'surname',
                'Document': 'title',
                'LicenceTerms': 'licence_terms_name',
                'Repository': 'repository_name'
            }
            resource_short_name_mapping = {
                'LanguageResource': 'resource_short_name',
                'Project': 'project_short_name',
                'Organization': 'organization_short_name',
                'Group': 'organization_short_name',
                'Document': 'alternative_title',
                'LicenceTerms': 'licence_terms_short_name',
                'Repository': 'repository_additional_name'
            }
            initial_serializer = MetadataRecordSerializer(instance=self.metadata_record_of_manager)
            clean_data = nested_delete(initial_serializer.data, 'pk')
            new_resource_serializer = MetadataRecordSerializer(data=clean_data, context={'draft': True})
            new_resource_data = new_resource_serializer.initial_data
            entity_type = self.metadata_record_of_manager.described_entity.entity_type
            new_resource_data['described_entity'][resource_name_mapping[entity_type]] = {
                'en': resource_name
            }
            new_resource_data['described_entity'][sender_mapping_relation[entity_type]] = []
            if entity_type == 'Person':
                new_resource_data['described_entity']['given_name'] = {
                    'en': given_name
                }

            if entity_type == 'LanguageResource':
                new_resource_data['described_entity']['version'] = version
                lr_type = self.metadata_record_of_manager.described_entity.lr_subclass.lr_type
                if lr_type == 'ToolService':
                    distribution = new_resource_data['described_entity']['lr_subclass']['software_distribution']
                    for dist in distribution:
                        dist['package'] = None
                else:
                    distribution = new_resource_data['described_entity']['lr_subclass']['dataset_distribution']
                    for dist in distribution:
                        dist['dataset'] = None
                if functional or self.has_content_file:
                    keep_validators = False
            if entity_type not in ['Person']:
                new_resource_data['described_entity'][resource_short_name_mapping[entity_type]] = None

            new_resource_data['management_object'] = {
                'status': DRAFT,
                'curator': self.curator.pk,
                'legal_validator': self.legal_validator.pk if (self.legal_validator and keep_validators) else None,
                'metadata_validator': self.metadata_validator.pk if (
                        self.metadata_validator and keep_validators) else None,
                'technical_validator': self.technical_validator.pk if (
                        self.technical_validator and keep_validators) else None,
                'functional_service': functional
            }
            new_resource_serializer.is_valid(raise_exception=True)
            new_resource = new_resource_serializer.save()

            if keep_validators:
                if self.legal_validator:
                    legal_val = Validator.objects.get(user=self.legal_validator, assigned_for='Legal')
                    legal_val.assigned_to.add(new_resource.management_object.id)
                    legal_val.save()
                if self.metadata_validator:
                    meta_val = Validator.objects.get(user=self.metadata_validator, assigned_for='Metadata')
                    meta_val.assigned_to.add(new_resource.management_object.id)
                    meta_val.save()
                if self.technical_validator:
                    tech_val = Validator.objects.get(user=self.technical_validator, assigned_for='Technical')
                    tech_val.assigned_to.add(new_resource.management_object.id)
                    tech_val.save()

            return new_resource
        return None


class Validator(models.Model):
    """
    Class that manages the validation assignments of users
    """

    class Meta:
        verbose_name = 'Resource Validator'
        verbose_name_plural = 'Resource Validators'
        constraints = [
            models.UniqueConstraint(fields=['user', 'assigned_for'], name='Validator constraint')
        ]

    user = models.ForeignKey(ELGUser,
                             null=True,
                             on_delete=models.CASCADE,
                             related_name='validator')

    assigned_for = models.CharField(
        choices=[('Metadata', 'Metadata'), ('Legal', 'Legal'), ('Technical', 'Technical')],
        max_length=10,
        null=True
    )

    assigned_to = models.ManyToManyField(
        'management.Manager',
        related_name='assignment_of_manager_object',
        blank=True
    )

    date = models.DateField(
        auto_now_add=True,
        null=True
    )

    def save(self, *args, **kwargs):
        self.full_clean()
        super().save()

    def full_clean(self, exclude=None, validate_unique=True):
        if not (has_role(self.user, 'technical_validator') or
                has_role(self.user, 'legal_validator') or
                has_role(self.user, 'metadata_validator')):
            raise ValidationError(f' User {self.user} does not have validation permissions.')

        if not ((self.assigned_for == 'Technical' and has_role(self.user, 'technical_validator')) or
                (self.assigned_for == 'Legal' and has_role(self.user, 'legal_validator')) or
                (self.assigned_for == 'Metadata' and has_role(self.user, 'metadata_validator'))):
            raise ValidationError(f' User {self.user} is being assigned for the wrong aspect.')

    def __str__(self):
        return f'{self.assigned_for} validator {self.user.username}'


class CatalogueDataReport(Manager):
    class Meta:
        proxy = True
